/*
 * File name: LineSegment.java
 * Date:      2014/11/09 19:40
 * Author:    Jan Faigl
 */
package cz.cvut.fel.pr1;

/**
 *
 * @author jf
 */
public class LineSegment extends Geom {

    private final Point p0;
    private final Point p1;

    /**
     *
     * @param pt1
     * @param pt2
     */
    public LineSegment(Point pt1, Point pt2) {
        super(null);
        if (pt1 == null || pt2 == null || pt1.equals(pt2)) {
            throw new IllegalArgumentException();
        }
        p0 = pt1;
        p1 = pt2;
    }

    /**
     *
     * @return
     */
    public Point getP0() {
        return p0;
    }

    /**
     *
     * @return
     */
    public Point getP1() {
        return p0;
    }

    /**
     *
     * @param geom
     * @return
     */
    @Override
    public boolean isEqual(Geom geom) {
        boolean ret = geom == this;
        if (!ret && geom instanceof LineSegment) {
            LineSegment s = (LineSegment) geom;
            ret
                    = (p0.equals(s.p0) && p1.equals(s.p1))
                    || (p1.equals(s.p0) && p0.equals(s.p1));
        }
        return ret;
    }

    /**
     *
     * @param pt
     * @return
     */
    public boolean isInside(Point pt) {
        if (pt == null) {
            return false;
        } else {
            boolean collinear = GeomUtil.wind(p0, p1, pt) == 0;
            return collinear && GeomUtil.inBetween(p0, p1, pt);
        }
    }

    /**
     *
     * @param geom
     * @return
     */
    @Override
    public boolean isInside(Geom geom) {
        if (geom == null) {
            return false;
        }
        boolean ret = this == geom;
        if (!ret && geom instanceof Point) {
            ret = isInside((Point) geom);
        }
        return ret;
    }

    @Override
    public String getShapeName() {
        return "LineSegment";
    }

}
